# copyright= 'Huynh Duong Phuong Vi @ 2013-2014'
# suforyou.vn@gmail.com
module S4U
module S4u_AlignTool 
class AlignTool
def initialize(alignfix=0)   
    @alignfix=alignfix
    @e1=[]
    @e2=[]
    @s4u_aligntoolStrings=S4U::S4u_AlignTool::S4u_aligntoolStrings
    self.reset(nil)
end
def activate       
     self.setstatus(nil)    
end
def setstatus(view)
    case @align_mode
    when 1
      if  @selectedge1==nil
        if @e1.length==0
            if @alignfix==0
                Sketchup.status_text = @s4u_aligntoolStrings.GetString("Select target edge -> align || press TAB -> align+move")
            else
                Sketchup.status_text = @s4u_aligntoolStrings.GetString("Select target edge -> align+move || press TAB -> align")
            end
        else
            if @alignfix==0              
                    Sketchup.status_text=@s4u_aligntoolStrings.GetString("Select aligned edges || press TAB -> align+move || press UP,DOWN or Right Mouse -> opposite Align")
             else   
                    Sketchup.status_text=@s4u_aligntoolStrings.GetString("Select align+moved edges || press TAB -> align || press UP,DOWN or Right Mouse -> opposite Align")
            end       
        end
	  else           
       if @selectedge2.length==0 
           if @alignfix==0
              Sketchup.status_text = @s4u_aligntoolStrings.GetString("Select aligned edges || press hold Ctrl(Alt on Mac) -> multiselect")
           else
              Sketchup.status_text = @s4u_aligntoolStrings.GetString("Select align+moved edges || press hold Ctrl(Alt on Mac) -> multiselect")
           end  
       else
          if @mulsel==1
              if @alignfix==0
                 Sketchup.status_text = @s4u_aligntoolStrings.GetString("Select aligned edges || Double-Click -> finish") 
              else   
                 Sketchup.status_text = @s4u_aligntoolStrings.GetString("Select align+moved edges || Double-Click -> finish")
              end
          end
       end
	  end
	when 2
      if @selectface1==nil
			if @e2.length==0
				if @alignfix==0
					Sketchup.status_text = @s4u_aligntoolStrings.GetString("Select target face -> align || press TAB -> align+move")
				else
					Sketchup.status_text = @s4u_aligntoolStrings.GetString("Select target face -> align+move || press TAB -> align")
				end
			else 
                if @alignfix==0              
                    Sketchup.status_text=@s4u_aligntoolStrings.GetString("Select aligned faces || press TAB -> align+move || press UP,DOWN or Right Mouse -> opposite Align")
                else   
                    Sketchup.status_text=@s4u_aligntoolStrings.GetString("Select align+moved faces || press TAB -> align || press UP,DOWN or Right Mouse -> opposite Align")
                end           
			end       
      else    
			if @selectface2.length==0
				if @alignfix==0
					Sketchup.status_text = @s4u_aligntoolStrings.GetString("Select aligned faces || press hold Ctrl(Alt on Mac) for multiselect")
				else
					Sketchup.status_text = @s4u_aligntoolStrings.GetString("Select align+moved faces || press hold Ctrl(Alt on Mac) for multiselect")
				end         
		   else
			   if @mulsel==1
				  if @alignfix==0
					 Sketchup.status_text = @s4u_aligntoolStrings.GetString("Select aligned faces || Double-Click for finish") 
				  else   
					 Sketchup.status_text = @s4u_aligntoolStrings.GetString("Select align+moved faces || Double-Click for finish")
				  end
			   end                               
		   end
      end
    else
        if @selectface1==nil or  @selectedge1==nil			
                if @alignfix==0              
                    Sketchup.status_text=@s4u_aligntoolStrings.GetString("Select aligned Edges(or Faces) || press TAB -> align+move || press UP,DOWN or Right Mouse -> opposite Align")
                else   
                    Sketchup.status_text=@s4u_aligntoolStrings.GetString("Select align+moved Edges(or Faces) || press TAB -> align || press UP,DOWN or Right Mouse -> opposite Align")
                end                 
       end            
    end
    view.invalidate if view!=nil
end
def draw(view) 	
     self.draw_over(view)               
     if @align_mode==1
          self.draw_edge_select(view)  
     else
          self.draw_face_select(view) if @align_mode==2
     end
end
def draw_edge_select(view)    
     view.line_width = 5
     if @selectedge1      
          view.drawing_color = "blue"
          selectedge=@selectedge1 
          cpstart=selectedge.start.position.clone      
          cpend=selectedge.end.position.clone
          cpstart.transform! @transedge1
          cpend.transform! @transedge1
          view.draw_line(cpstart,cpend) 
     end    
     if @selectedge2.length>0
         view.drawing_color = "blueviolet"
        (0..@selectedge2.length-1).each{ |i|
			selectedge=@selectedge2[i]
			cpstart=selectedge.start.position.clone        
			cpend=selectedge.end.position.clone
			if not @element2[i].is_a?( Sketchup::Edge) 
				cpstart.transform! @transedge2[i]
				cpend.transform! @transedge2[i]   
			end
			view.draw_line(cpstart ,cpend) 
        }
     end
end
def draw_face_select(view)
    view.line_width = 5
    view.drawing_color = "blue"                      
	@ps1<< @ps1[0]
	view.draw_polyline @ps1  	
    if @selectface2.length>0 #and  @mulsel==1
           view.drawing_color = "blueviolet"             
           (0..@selectface2.length-1).each{ |i|
				sf=@selectface2[i]
				@ps2[i]<< @ps2[i][0]
				view.draw_polyline @ps2[i]				
           }
    end
end
def draw_over(view)
    view.drawing_color = "red"
    view.line_width = 5                  
    if @selectedge.is_a?(Sketchup::Edge) and @align_mode!=2 
        ed=@selectedge
        p1=ed.start.position
        p2=ed.end.position                  
        p1.transform! @trans       
        p2.transform! @trans
        view.draw_line(p1,p2)  
        return true
    else   
		if @selectface.is_a?( Sketchup::Face) and @align_mode!=1
			ps=@selectface.outer_loop.vertices.collect{|p| p.position.transform @trans}         		
			if self.on_face(@ip.position,@selectface,ps)
				ps<< ps[0]
				view.draw_polyline ps 
		    end
			return true		
		end
    end
    return false
end
def on_face(p,face,psver)
    return true
end
def onMouseMove(flags, x, y, view)  
		@ip = view.inputpoint x, y		
		if @ip.valid? 
		  @selectedge=@ip.edge 
		  @selectface=@ip.face 		  
		  @trans=@ip.transformation                   
		  self.setstatus(view)	
		end
end
def onLButtonDoubleClick(flags, x, y, view)
		self.align_edgeonedge if @selectedge1 and @selectedge2.length>0 and @align_mode==1 and @mulsel==1        
		self.align_faceonface if @selectface1 and @selectface2.length>0 and @align_mode==2 and @mulsel==1		
		self.setstatus(view)
end
def onLButtonDown(flags, x, y, view)     
		if @ctrl_down_time #and (Time.now-@ctrl_down_time>0.1)
			 @mulsel= 1 			 
	    end
		ip1 = view.inputpoint x,y
		return nil if not ip1.valid?
		trans1= ip1.transformation 
		selectface1=ip1.face
		selectedge1=ip1.edge
		if @align_mode==0  
			if selectedge1.is_a?Sketchup::Edge
				@align_mode=1 
			else
				@align_mode=2 if selectface1.is_a?Sketchup::Face
			end 
		end      
	    ph = view.pick_helper
	    ph.do_pick x,y
	    element = ph.best_picked
		element1 = ph.picked_element
	    selectface=ph.picked_face
		selectedge=ph.picked_edge  
		case @align_mode
		when 1 		
			if @selectedge1==nil       
				@e1=[] ;@e2=[]
				@selectedge1=selectedge1
				@transedge1= trans1     
			else         
				if  @selectedge2.length==0 or(@mulsel==1 and @selecting)
				  if selectedge and ( element or element1)
					@selectedge2.push selectedge
					@element2.push (element ? element : element1) 				
					@transedge2.push ph.transformation_at(ph.count-1)    
				  end 
				end                
			end
		when 2        
				if @selectface1==nil     
					if selectface1.is_a?Sketchup::Face  
						 @e2=[];@e1=[]
						 @ps1=[]
						 @ps1=selectface1.outer_loop.vertices.collect{|p| p.position.transform trans1}         
						 if self.on_face(ip1.position,selectface1,@ps1)
							@selectface1=selectface1             
							@transface1=trans1   							
						 end						
				    end
				else           
					if  @selectface2.length==0 or( @mulsel==1 and @selecting)
					  if selectface and ( element or element1)	
						 trans2=ph.transformation_at(ph.count-1) 
						 ps=[]
						 ps=selectface.outer_loop.vertices.collect{|p| p.position.transform trans2}         
						 if self.on_face(ip1.position,selectface,ps)
							  @selectface2.push selectface
							  @element2.push (element ? element : element1) 
							  @transface2.push trans2
							  @ps2<< ps
						 end												
				      end
					end  					
				end
		end #mode 1  
end
def getMenu(menu)
    if @e1.length>0       
          self.rotate_elements_edge
    else                         
          self.rotate_elements_face if @e2.length > 0    
    end   
end
def normal_face(ver)    
    line=ver[0],ver[1]
    v2=ver[2].project_to_line line
    vx=ver[0].vector_to ver[1]
    vy=v2.vector_to ver[2]
    vz=vx.cross vy
    return vz
end
def onLButtonUp(flags, x, y, view)          
    self.align_edgeonedge if @selectedge1 and @selectedge2.length>0 and @align_mode==1 and @mulsel == 0 
    self.align_faceonface if @selectface1 and @selectface2.length>0 and @align_mode==2 and @mulsel == 0 
	self.setstatus(view)
end
def rotate_elements_face
		model = Sketchup.active_model
		entities = model.active_entities 
		model.start_operation @s4u_aligntoolStrings.GetString("Align Faces-Opposite")        
       (0..@e2.length-1).each{|i|
			e=@e2[i];cen=@center[i]
			if (not e.is_a?Sketchup::Face) and cen!=nil and @zaxis!=nil                 
				new_transform = Geom::Transformation.new(cen,@zaxis)     
				t=e.transformation    
				g=entities.add_group e
				g.transformation=new_transform
				e.transformation=new_transform.inverse*t  
				t=Geom::Transformation.new(cen,@zaxis.reverse) 
				g.transformation=t
				g.explode   
			end
       }	  
       model.commit_operation 
end
def rotate_elements_edge
		model = Sketchup.active_model
		entities = model.active_entities 
		model.start_operation @s4u_aligntoolStrings.GetString("Align Egdes-Opposite")
       (0..@e1.length-1).each{|i|
			e=@e1[i];cen=@center[i]
			if (not e.is_a?Sketchup::Edge) and  cen!=nil and @zaxis!=nil                 
				new_transform = Geom::Transformation.new(cen,@zaxis)     
				t=e.transformation    
				g=entities.add_group e
				g.transformation=new_transform
				e.transformation=new_transform.inverse*t  
				t=Geom::Transformation.new(cen,@zaxis.reverse) 
				g.transformation=t
				g.explode   
			end
       }	  
       model.commit_operation 
end
def onKeyDown(key, repeat, flags, view)
	 if (key == VK_CONTROL) or ((Sketchup.platform == :platform_osx) and (key==VK_ALT))
		 @ctrl_down_time=true
		 @selecting=true
	 end
end
def onKeyUp(key, repeat, flags, view)
	case key
	when VK_CONTROL
 		  @ctrl_down_time=nil
		  @selecting=false	
	when VK_ALT
		if (Sketchup.platform == :platform_osx)
			  @ctrl_down_time=nil
			  @selecting=false	
		end		 
	when 13
		 self.align_edgeonedge if @selectedge1 and @selectedge2.length>0 and @align_mode==1 and @mulsel == 1
		 self.align_faceonface if @selectface1 and @selectface2.length>0 and @align_mode==2 and @mulsel == 1
		 self.setstatus(view) 
	when VK_UP,VK_DOWN   
         if @e1.length>0       
            self.rotate_elements_edge
        else                         
            self.rotate_elements_face if @e2.length > 0    
        end  
    when 9
		@alignfix=1-@alignfix   
	when VK_LEFT,VK_RIGHT   
        @alignfix=1-@alignfix if (Sketchup.platform == :platform_osx)
	end		
	self.setstatus(view)
end
def align_edgeonedge
    model = Sketchup.active_model
    entities = model.active_entities   
    model.start_operation @s4u_aligntoolStrings.GetString("Align Edge")
		@e1=[]
        cp1start=@selectedge1.start.position
        cp1end=@selectedge1.end.position   
        cp1start.transform! @transedge1
        cp1end.transform! @transedge1
        v1=cp1start.vector_to cp1end 
        line = [cp1start,cp1end]
        midedge1=Geom::Point3d.new( (cp1start.x+cp1end.x)/ 2,(cp1start.y+cp1end.y)/ 2,(cp1start.z+cp1end.z)/ 2)
        @e1=@element2;@center=[]  
        @zaxis=v1
    (0..@selectedge2.length-1).each{ |i|
        selectedge2=@selectedge2[i]
        element2=@element2[i]
        transedge2=@transedge2[i]      
        cp2start=selectedge2.start.position    
        cp2end=selectedge2.end.position
        if not element2.is_a?( Sketchup::Edge)  
          cp2start=cp2start.transform transedge2
          cp2end=cp2end.transform transedge2
          midedge2=Geom::Point3d.new( (cp2start.x+cp2end.x)/ 2,(cp2start.y+cp2end.y)/ 2,(cp2start.z+cp2end.z)/ 2)
          v2=cp2start.vector_to cp2end 
          new_transform2 = Geom::Transformation.new(midedge2,v2)             
          tmpgrp=entities.add_group   
          t=element2.transformation     
          g=tmpgrp.entities.add_group element2
          g.transformation=new_transform2
          element2.transformation=new_transform2.inverse*t          
          pointonline1 = cp2start.project_to_line line
          pointonline2 = cp2end.project_to_line line
          midonline=midedge2.project_to_line line
          if pointonline1==pointonline2
              v3=v1
          else
              v3=pointonline1.vector_to pointonline2
          end      
          if @alignfix==1
               new_transform3 = Geom::Transformation.new(midedge1,v3) 
          else
               new_transform3 = Geom::Transformation.new(midonline,v3)            
          end       
          @center.push new_transform3.origin
          g.transformation=new_transform3  
          g.explode
      else
          pointonline1 = cp2start.project_to_line line
          pointonline2 = cp2end.project_to_line line 
          v1=nil,v2=nil
          if @alignfix==1
               v1 = cp2start.vector_to cp1start          
               v2 = cp2end.vector_to cp1end          
          else
               v1 = cp2start.vector_to pointonline1
               v2 = cp2end.vector_to pointonline2
          end  
          sub_entities=[]; vector_array=[]          
          sub_entities << selectedge2.vertices[0]  ;vector_array << v1      
          sub_entities << selectedge2.vertices[1]  ;vector_array << v2             
          entities.transform_by_vectors sub_entities, vector_array           
      end
    }
    self.reset(nil)
    model.commit_operation
end
def align_faceonface 
    model = Sketchup.active_model
    entities = model.active_entities   
    model.start_operation @s4u_aligntoolStrings.GetString("Align Faces")
	@e2=[]
    ver=@selectface1.vertices.collect{|v| v.position.transform @transface1}
    @zaxis=normal_face(ver)
    cp1=self.centerface(@selectface1)
    cp1.transform! @transface1
    new_transform1 = Geom::Transformation.new(cp1,@zaxis)   
    plane = [cp1,@zaxis]
    @e2=@element2;@center=[]  ;@sub_entities=[]; @vector_array=[]
   (0..@selectface2.length-1).each{ |i|
    element2=@element2[i]
    selectface2=@selectface2[i]
    transface2=@transface2[i]
    if not element2.is_a?( Sketchup::Face) and selectface2.is_a?Sketchup::Face                
			cp2=self.centerface(selectface2)
			cp2.transform! transface2        
            ps=nil
            ps = selectface2.outer_loop.vertices.collect {|p| 
                 p.position.transform! transface2  }                 
            ps=ps.push ps[0]
            ft=entities.add_face ps
            v2= ft.normal
            normalface2=selectface2.normal
            normalface2.transform! transface2
            v2.reverse! if (v2.angle_between normalface2)>= Math::PI/ 2
            gt=entities.add_group ft
            entities.erase_entities gt              
			new_transform2 = Geom::Transformation.new(cp2,v2)     
			tmpgrp=entities.add_group
			t=element2.transformation   			
			g=tmpgrp.entities.add_group element2
			g.transformation=new_transform2
			element2.transformation=new_transform2.inverse*t           
			pointonplane = cp2.project_to_plane plane         
			if @alignfix==1
				 new_transform3 = Geom::Transformation.new(cp1,@zaxis) 
			else
				 new_transform3 = Geom::Transformation.new(pointonplane,@zaxis)               
			end
			@center.push new_transform3.origin
			g.transformation=new_transform3
			g.explode              
			
    else   
		if selectface2.is_a?Sketchup::Face 			
			selectface2.vertices.each{|ver2|
				p=ver2.position
				p1 = p.project_to_plane plane
				v=p.vector_to p1
                if not @sub_entities.index(ver2)
                    @sub_entities << ver2 
                    @vector_array << v
                end
			} 
			        
		end
	end         
    }
    entities.transform_by_vectors @sub_entities, @vector_array 
    self.reset(nil)
    model.commit_operation
end
def reset(view)
    @align_mode=0
    @mulsel=0
    @ctrl_down_time=nil
    
    @selectface1=nil
    @selectface2=[]
    @element1=nil
    @element2=[]
    @selectface=nil
    @trans=nil
    @transface1=nil
    @transface2=[]
    @ps2=[]
	
    @selectedge=[]
    @selectedge1=nil
    @selectedge2=[]
    @selectedge=nil
    @transedge1=nil
    @transedge2=[]    
    self.setstatus(view)
end
def centerface(fa)
      cp=Geom::Point3d.new
      if fa.is_a?Sketchup::Face
          numver=fa.outer_loop.vertices.length
          fa.outer_loop.vertices.each{|v|
          cp.x=cp.x+v.position.x
          cp.y=cp.y+v.position.y
          cp.z=cp.z+v.position.z
        }
        cp.x=cp.x/ numver
        cp.y=cp.y/ numver
        cp.z=cp.z/ numver      
      end
      return cp
end
def resume(view)
   self.setstatus(view)
end
end
def self.aligntool(alignfix=0)      
    Sketchup.active_model.select_tool AlignTool.new alignfix
end
    #require 'langhandler.rb'
	#S4u_aligntoolStrings = LanguageHandler.new("s4u_aligntool.strings")
end
end
#S4U::S4u_AlignTool.aligntool

